<?php

namespace %NAMESPACE%\Lib;

use Picea\Picea;
use Storage\Session;
use Ulmus\User\Entity\User;
use Ulmus\User\Lib\Authenticate;
use %NAMESPACE%\Entity;

/**
 * @Security("locked" => false)
 * @RouteParam("methods" => [ "GET", "POST" ])
 */
trait ControllerTrait {
    use \Lean\ControllerTrait;

    public ? \Ulmus\User\Entity\User $user;

    protected Authenticate $authenticate;

    public function __construct(Picea $picea, Session $session, Authenticate $authenticate) {
        $this->initializeController($picea, $session, $authenticate);
    }

    public function initializeController(Picea $picea, Session $session, Authenticate $authenticate) {
        $this->picea = $picea;
        $this->authenticate = $authenticate;
        $this->session = $session;
        $this->user = $authenticate->rememberMe( Entity\User::repository() ) ?: new Entity\User();
    }

}